#![allow(dead_code)]

mod tag;
mod util;
mod runtime;
mod interface; pub use interface::*;
mod encoding; pub use encoding::*;

pub fn test() {
    let mut data = Varying::new();
    data.set(*Natural::with(79));

    let out = encode(*data);
    print!("[{}]: ", out.len());
    for byte in &out {
        print!("{:02x} ", *byte);
    } println!("\n");

    match decode(&out, &mut 0) {
        Ok(ty) => match ty {
            Type::Varying(data) => {
                println!("Ok: {}", Natural::from(data.get()).unwrap().get());
            }
            _ => { println!("Other"); }
        },
        Err(_) => { println!("Failure"); }
    }
}

#[cfg(test)]
mod tests;
